Index: orxonox/trunk/src/Makefile.am
===================================================================
--- orxonox/trunk/src/Makefile.am	(revision 2077)
+++ orxonox/trunk/src/Makefile.am	(revision 2190)
@@ -1,4 +1,4 @@
 AM_CXXFLAGS="-I/usr/X11R6/include"
-AM_LDFLAGS="-L/usr/Mesa-6.0.1/lib  -L/usr/X11R6/lib -lXt -lX11"
+AM_LDFLAGS="-L/usr/Mesa-6.0.1/lib  -L/usr/X11R6/lib -lXt -lX11" $(MWINDOWS)
 
 #"-O3 -pedantic -fPIC -ffast-math -I/usr/X11R6/include"
@@ -6,8 +6,8 @@
 
 bin_PROGRAMS=orxonox
-orxonox_SOURCES=orxonox.cc world.cc environment.cc player.cc npc.cc input_output.cc data_tank.cc ai.cc shoot_laser.cc shoot_rocket.cc world_entity.cc synchronisable.cc vector.cc ability.cc power_up.cc
+orxonox_SOURCES=orxonox.cc world.cc player.cc data_tank.cc world_entity.cc vector.cc camera.cc collision.cc command_node.cc ini_parser.cc keynames.cc track.cc 
 
 #  uncomment the following if bencoder requires the math library
-#gui_LDADD=-lm
+#orxonox_LDADD=-lm
 
 #EXTRA_DIST=orxonox.lsm.in orxonox.spec.in orxonox.texinfo
Index: orxonox/trunk/src/camera.cc
===================================================================
--- orxonox/trunk/src/camera.cc	(revision 2190)
+++ orxonox/trunk/src/camera.cc	(revision 2190)
@@ -0,0 +1,164 @@
+
+
+/* 
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: Christian Meyer
+   co-programmer: ...
+*/
+
+#include "camera.h"
+#include "world.h"
+#include "world_entity.h"
+
+using namespace std;
+
+/**
+   \brief creates a Camera
+   
+   This standard constructor sets all parameters to zero
+*/
+Camera::Camera ()
+{
+	bound = NULL;
+}
+
+/**
+   \brief default destructor
+*/
+Camera::~Camera ()
+{
+}
+
+/**
+   \brief time based actualisation of camera parameters
+   \param deltaT: The amount of time that has passed in milliseconds
+   
+   This is called by the World in every time_slice, use it to do fancy time dependant effects (such 
+   as smooth camera movement or swaying).
+*/
+void Camera::time_slice (Uint32 deltaT)
+{
+	update_desired_place ();
+	jump (NULL);
+}
+
+/**
+  \brief this calculates the location where the track wants the camera to be
+   
+	This refreshes the placement the camera should have according to the bound entity's position on the track.
+*/
+void Camera::update_desired_place ()
+{
+		Orxonox *orx = Orxonox::getInstance();
+		Location lookat;
+		
+		if( bound != NULL)
+		{
+			bound->get_lookat (&lookat);
+			orx->get_world()->calc_camera_pos (&lookat, &desired_place);
+		}
+		else
+		{
+			desired_place.r = Vector (0,0,0);
+			desired_place.w = Quaternion (); 
+		}
+}
+
+/**
+  \brief initialize rendering perspective according to this camera
+   
+	This is called immediately before the a rendering cycle starts, it sets all global rendering options as
+	well as the GL_PROJECTION matrix according to the camera.
+*/
+void Camera::apply ()
+{
+	glMatrixMode (GL_PROJECTION);
+  glLoadIdentity ();
+		// view
+		// TO DO: implement options for frustum generation
+	glFrustum( -1.0,1.0,-1.0,1.0,1.5,250.0);
+//Vector up(0,0,1);
+//Vector dir(1,0,0);
+//Quaternion q(dir,up);
+//float matrix[4][4];
+//q.conjugate().matrix (matrix);
+//glMultMatrixf ((float*)matrix);
+//glTranslatef (10,0,-5);
+//
+//dir = Vector(-1,-1,0);
+//q = Quaternion( dir, up);
+//glMatrixMode (GL_MODELVIEW);
+//glLoadIdentity ();
+//q.matrix (matrix);
+//glMultMatrixf ((float*)matrix);
+//glTranslatef (2,2,0);
+//
+//glBegin(GL_TRIANGLES);
+//glColor3f(1,0,0);
+//glVertex3f(0,0,0.5);
+//glColor3f(0,1,0);
+//glVertex3f(-0.5,0,-1);
+//glColor3f(0,0,1);
+//glVertex3f(0.5,0,-1);
+//glEnd();	
+
+  	// rotation
+  float matrix[4][4];
+  actual_place.w.conjugate().matrix (matrix);
+  glMultMatrixf ((float*)matrix);
+  	// translation
+  glTranslatef (-actual_place.r.x, -actual_place.r.y,- actual_place.r.z);
+  
+  glMatrixMode (GL_MODELVIEW);
+  glLoadIdentity ();
+  
+  printf("Camera@%f/%f/%f\n",actual_place.r.x,actual_place.r.y,actual_place.r.z);
+  Vector unique(1,0,0);
+  Vector test = actual_place.w.apply (unique);
+  printf("Camera&%f/%f/%f\n", test.x, test.y, test.z);
+}
+
+/**
+  \brief set the camera position
+  \param plc: The Placement to set the camera to 
+	
+	This will set the actual and desired placement of the camera to plc
+*/
+void Camera::jump (Placement* plc = NULL)
+{
+	if( plc == NULL)
+	{
+		actual_place = desired_place;
+	}
+	else
+	{
+		desired_place = *plc;
+		actual_place = *plc;
+	}
+}
+
+/**
+  \brief bind the camera to an entity
+  \param entity: The enitity to bind the camera to
+	
+	This sets the focus of the camera to the given entity. This means that it will use the given WorldEntity's
+	Location and get_lookat() to determine the viewpoint the camera will render from.
+	Note that you cannot bind a camera to a free entity.
+*/
+void Camera::bind (WorldEntity* entity)
+{
+	if( entity != NULL)
+	{
+		if( entity->isFree ()) printf("Cannot bind camera to free entity");
+		else bound = entity;
+	} 
+}
Index: orxonox/trunk/src/camera.h
===================================================================
--- orxonox/trunk/src/camera.h	(revision 2190)
+++ orxonox/trunk/src/camera.h	(revision 2190)
@@ -0,0 +1,39 @@
+/*! 
+    \file camera.h
+    \brief Viewpoint controlling class definitions
+*/ 
+
+#ifndef CAMERA_H
+#define CAMERA_H
+
+#include "stdincl.h"
+
+class WorldEntity;
+
+//! Camera
+/**
+ 	This class controls the viewpoint from which the World is rendered. To use the Camera it has
+ 	to be bound to a WorldEntity which serves as the reference focus point. The Camera itself calls
+ 	the WorldEntity::get_lookat() and World::calc_camera_pos() functions to calculate the position it
+ 	currently should be in.
+*/
+class Camera {
+ private:
+ 	WorldEntity* bound;		//!< the WorldEntity the Camera is bound to
+ 	Placement actual_place;	//!< the Camera's current position
+ 	Placement desired_place; //!< where the Camera should be according to calculations
+
+	void update_desired_place ();
+	
+ public:
+  Camera ();
+  ~Camera ();
+
+	void time_slice (Uint32 deltaT);
+	void apply ();
+	void bind (WorldEntity* entity);
+	void jump (Placement* plc);
+
+};
+
+#endif
Index: orxonox/trunk/src/collision.cc
===================================================================
--- orxonox/trunk/src/collision.cc	(revision 2190)
+++ orxonox/trunk/src/collision.cc	(revision 2190)
@@ -0,0 +1,381 @@
+
+
+/* 
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: Christian Meyer
+   co-programmer: ...
+*/
+
+
+#include "collision.h"
+
+using namespace std;
+
+/**
+   \brief simple CollisionCluster constructor
+   \param rad: the radius of the base sphere
+   \param mid: the middle point of the sphere
+*/
+CollisionCluster::CollisionCluster (float rad = 1.0, Vector mid = Vector(0,0,0))
+{
+  root = (CC_Tree*) malloc( sizeof( CC_Tree));
+  root->n = 0;
+  root->data.ID = 0;
+  root->r = rad;
+  root->m = mid;
+}
+
+/**
+   \brief loads a CollisionCluster from a data file
+   \param filename: self-explanatory
+*/
+CollisionCluster::CollisionCluster (char* filename)
+{
+  FILE* stream;
+  char hbuffer[3];
+  stream = fopen (filename, "rb");
+  if( stream == NULL)
+  {
+    root = NULL;
+    return;
+  }
+  if( fread (hbuffer, sizeof( char), 2, stream) != 2)
+  {
+    root = NULL;
+    return;
+  }
+  
+  hbuffer[2] = 0;
+  if( strcmp (hbuffer, "CC"))
+  {
+    root = NULL;
+    return;
+  }
+  
+  root = load_CC_Tree (stream);
+  fclose (stream);
+}
+
+/**
+   \brief Simple destructor that cleans up all the mess
+*/
+CollisionCluster::~CollisionCluster ()
+{
+  free_CC_Tree( root);
+}
+
+/**
+   \brief stores the CollisionCluster into a file
+   \param filename: self-explanatory
+   \return zero on success, -1 on error
+*/
+int CollisionCluster::store (char* filename)
+{
+  int r;
+  FILE* stream;
+  stream = fopen( filename, "wb");
+  if( stream == NULL) return -1;
+  r = save_CC_Tree (root, stream);
+  fclose (stream);
+  return r;
+}
+
+/**
+   \brief performs a collision check between a CollisionCluster and a Line
+   \param pa: pointer to the Placement of the CollisionCluster
+   \param a: pointer to the CollisionCluster
+   \param ahitflags: pointer to an unsigned long to store hitlocation data
+   \param trace: pointer to the Line
+   \param impactpoint: pointer to a Vector where the point of intersection is stored in
+   \return true on collision, false otherwise. If true is returned, the flag in ahitflags that symbolises the hit subsphere is set, and impactpoint is set to the Location where the intersection occured
+*/
+bool check_trace (const Placement* pa, const CollisionCluster* a, unsigned long* ahitflags, const Line* trace, Vector* impactpoint)
+{
+	CC_Tree* t;
+	if( (t = a->root) == NULL) return false;
+	
+  return cctree_trace( pa, t, ahitflags, trace, impactpoint);
+}
+
+/**
+   \brief performs a collision check between two CollisionClusters
+   \param pa: pointer to the Placement of the first CollisionCluster
+   \param a: pointer to the first CollisionCluster 
+   \param ahitflags: pointer to an unsigned long to store hitlocation data on the first CollisionCluster
+   \param pb: pointer to the Placement of the second CollisionCluster
+   \param b: pointer to the second CollisionCluster
+   \param bhitflags: pointer to an unsigned long to store hitlocation data on the second CollisionCluster
+   \return true on collision, false otherwise
+   If true is returned, all flags in ahitflags and bhitflags that symbolize intersecting subspheres in the respective CollisionCluster are set
+*/
+bool check_collision (const Placement* pa, const CollisionCluster* a, unsigned long* ahitflags, const Placement* pb, const CollisionCluster* b, unsigned long* bhitflags)
+{
+  CC_Tree* ta, *tb;
+  if( (ta = a->root) == NULL) return false;
+  if( (tb = b->root) == NULL) return false;
+  
+  return cctree_iterate(pa, ta, ahitflags, pb, tb, bhitflags);
+}
+
+/**
+   \brief performs an intersection check between two spheres
+   \param m1: center point of first sphere
+   \param r1: radius of first sphere
+   \param m2: center point of second sphere
+   \param r2: radius of second sphere
+   \return true on intersection, false otherwise
+*/
+bool sphere_sphere_collision( Vector m1, float r1, Vector m2, float r2)
+{
+  if ((m1-m2).len() < r1+r2) return true;
+  return false;
+}
+
+/**
+   \brief performs an intersection check between a Line and a sphere
+   \param m: center point of the sphere
+   \param r: radius of the sphere
+   \param l: pointer to the Line
+   \param impactpoint: pointer to a buffer to store the point of intersection
+   \return true on intersection, false otherwise. If true is returned, impactpoint is set to the loaction where the intersection occured
+*/
+bool trace_sphere_collision( Vector m, float r, const Line* l, Vector* impactpoint)
+{
+  float A, B, C, D, t[2];
+  Vector d = l->r - m;
+  int i;
+  
+  A = l->a * l->a;
+  B = 2 * (l->a * d);
+  C = (d*d) - r*r;
+  D = B*B - 4*A*C;
+  
+  if (D < 0) return false;
+  
+  t[0] = (-B+sqrt(D))/(2*A);
+  t[1] = (-B-sqrt(D))/(2*A);
+  
+  if( (t[0] > 1 || t[0] < 0) && (t[1] < 0 || t[1] > 1)) return false;
+  if( t[0] > t[1]) i = 0;
+  else i = 1;
+
+  impactpoint->x = (l->r + (l->a * t[i])).x;
+  impactpoint->y = (l->r + (l->a * t[i])).y;
+  impactpoint->z = (l->r + (l->a * t[i])).z;
+  
+  return true;
+}
+
+bool cctree_iterate(const Placement* pa, CC_Tree* ta, unsigned long* ahitflags, const Placement* pb, CC_Tree* tb, unsigned long* bhitflags)
+{
+  bool r = false;
+  int ia, ib;
+  Vector mra = pa->r + pa->w.apply(ta->m);
+  Vector mrb = pb->r + pb->w.apply(tb->m);
+  CC_Tree* use_a, *use_b;
+  
+  if( use_a == NULL || use_b == NULL) return false;
+  
+  if( sphere_sphere_collision( mra, ta->r, mrb, tb->r))
+  {
+    if( ta->n == 0 && tb->n == 0)
+    {
+      setflag( ahitflags, ta->data.ID);
+      setflag( bhitflags, tb->data.ID);
+      return true;
+    }
+    for( ia = 0; ia < ta->n || ta->n == 0; ia++)
+    {
+      if( ta->n == 0) use_a = ta;
+      else use_a = ta->data.b[ia];
+      for( ib = 0; ib < tb->n || ta->n == 0; ib++)
+      {
+        if( ta->n == 0) use_b = ta;
+        else use_b = ta->data.b[ib];
+        
+        r = r || cctree_iterate( pa, use_a, ahitflags, pb, use_b, bhitflags);
+        
+        if( tb->n == 0) break;
+      }
+      if( ta->n == 0) break;
+    }
+    return r;
+  }
+  
+  return false;
+}
+
+/**
+   \brief sets the <ID>th flag in flags
+   \param flags: pointer to the long used for flagging
+   \param ID: number of the flag to be set
+*/
+void setflag( unsigned long* flags, unsigned long ID)
+{
+  unsigned long f;
+  f = 1;
+  for( int i = 0; i < ID; i++)
+  {
+    f *= 2;
+  }
+  *flags = *flags | f;
+  return;
+}
+
+/**
+   \brief frees the memory allocated in a CC_Tree
+*/
+void free_CC_Tree( CC_Tree* tree)
+{
+  if (tree == NULL) return;
+  for (int i = 0; i < tree->n; i++)
+  {
+    free_CC_Tree( tree->data.b[i]);
+  }
+  free( tree);
+}
+
+/**
+   \brief loads a CC_Tree from a stream
+*/
+CC_Tree* load_CC_Tree (FILE* stream)
+{
+  CC_Tree* tree = NULL;
+  CC_Tree** branches = NULL;
+  float buf[4];
+  unsigned long n;
+  unsigned long ID;
+  
+  // first load vector and radius
+  if (fread( buf, sizeof (float), 4, stream) != 4) return NULL;
+  // then the amount of subbranches
+  if (fread( &n, sizeof(unsigned long), 1, stream) != 1) return NULL;
+  // then ID or the subbranches
+  if ( n == 0)
+  {
+    if (fread( &ID, sizeof(unsigned long), 1, stream) != 1) return NULL;
+  }
+  else
+  {
+    branches = (CC_Tree**)malloc( sizeof(CC_Tree*) * n);
+    for( int i = 0; i < n; i++)
+    {
+      if ((branches[i] = load_CC_Tree (stream)) == NULL)
+      {
+        for( int j = 0; j < i; j++)
+        {
+          free_CC_Tree (branches[j]);
+          free (branches);
+          return NULL;
+        }
+      }
+    }
+  }
+  
+  // assemble
+  tree = (CC_Tree*) malloc (sizeof(CC_Tree));
+  tree->m.x = buf[0];
+  tree->m.y = buf[1];
+  tree->m.z = buf[2];
+  tree->r = buf[3];
+  tree->n = n;
+  if( n == 0) tree->data.ID = ID;
+  else tree->data.b = branches;
+  
+  // then return
+  return tree;
+}
+
+/**
+   \brief saves a CC_Tree to a stream
+*/
+int save_CC_Tree (CC_Tree* tree, FILE* stream)
+{
+  float buf[4];
+  
+  buf[0] = tree->m.x;
+  buf[1] = tree->m.y;
+  buf[2] = tree->m.z;
+  buf[3] = tree->r;
+  
+  // first save vector and radius
+  if (fwrite( buf, sizeof (float), 4, stream) != 4) return -1;
+  // then the amount of subbranches
+  if (fwrite( &(tree->n), sizeof(unsigned long), 1, stream) != 1) return -1;
+  // then ID or the subbranches
+  if ( tree->n == 0)
+  {
+    if (fwrite( &(tree->data.ID), sizeof(unsigned long), 1, stream) != 1) return -1;
+  }
+  else
+  {
+    for( int i = 0; i < tree->n; i++)
+    {
+      if ( save_CC_Tree (tree->data.b[i], stream) == -1) return -1;
+    }
+  }
+    
+  // then return
+  return 0;
+}
+
+bool cctree_trace( const Placement* p, CC_Tree* t, unsigned long* hitflags, const Line* trace, Vector* impactpoint)
+{
+  bool r = false;
+  int i;
+  Vector mr = p->r + p->w.apply (t->m);
+  CC_Tree* use_t;
+  Vector* ips;
+  unsigned long* hfs;
+  
+  if( trace_sphere_collision (mr, t->r, trace, impactpoint))
+  {
+  	if( t->n == 0)
+  	{
+  		setflag (hitflags, t->data.ID);
+  		return true;
+  	}
+  	else
+  	{
+  		ips = new Vector[t->n];
+  		hfs = new unsigned long[t->n];
+  		for (i = 0; i < t->n; i++) hfs[i] = 0;
+  		for (i = 0; i < t->n; i++)
+  		{
+  			r = r || cctree_trace (p, t->data.b[i], &(hfs[i]), trace, &(ips[i]));
+  		}
+  		if( r)
+  		{
+  			float kl = 0.0;
+  			float l = 0.0;
+  			int k = 0;
+  			for (i = 0; i < t->n; i++)
+  			{
+  				if( (kl = (trace->r - ips[i]).len()) > l)
+  				{
+  					l = kl;
+  					k = i;
+  				}
+  			}
+  			impactpoint->x = ips[k].x;
+  			impactpoint->y = ips[k].y;
+  			impactpoint->z = ips[k].z;
+  			*hitflags = hfs[k];
+  		}
+  		delete ips;
+  		delete hfs;
+  	}
+  	return r;
+  }
+  
+  return false;
+}
Index: orxonox/trunk/src/collision.h
===================================================================
--- orxonox/trunk/src/collision.h	(revision 2190)
+++ orxonox/trunk/src/collision.h	(revision 2190)
@@ -0,0 +1,69 @@
+/*! 
+    \file collision.h
+    \brief Basic collision detection
+*/ 
+
+#ifndef COLLISION_H
+#define COLLISION_H
+
+#include "vector.h"
+#include "coordinates.h"
+#include <stdlib.h>
+#include <stdio.h>
+#include <string.h>
+
+//! Tree structure used by the CollisionCluster
+typedef struct CC_Tree
+{
+  unsigned long n;
+  union
+  {
+  struct CC_Tree** b;
+  unsigned long ID;
+  } data;
+  float r;
+  Vector m;
+} CC_Tree;
+
+//! Basic collision detection class
+/**
+  This class implements a more or less efficient collision system based on nested hitzones.
+  Instead of using a brute force approach (try if any hitzone intersects with any other hitzone)
+  this features a tree of spheric hitzones. Only some of them are actually the solid groundstones
+  the collision model bases on, the others serve to group them into sets of spheres that are only
+  checked for collision when the assigned top level sphere has registered a collision, preventing
+  unnessessary checks (like between every sphere of two collision clusters at the other end of the world)
+  from being performed.
+  The CollisionCluster features collision detection between multiple CollisionClusters as well as
+  traceing a collision between a line of defined length and a cluster. In both cases the base spheres
+  that have intersected are marked with a flag in an unsigned long for hitlocation queries. In the case
+  of a trace, the exact point of interception is returned as well.
+*/
+class CollisionCluster {
+  
+  CC_Tree* root;
+  
+  
+ public:
+  CollisionCluster (float r, Vector m); // simple cluster
+  CollisionCluster (char* filename); // get cluster from file
+  ~CollisionCluster ();
+  
+  int store (char* filename);
+  
+  friend bool cctree_trace( const Placement* p, CC_Tree* t, unsigned long* hitflags, const Line* trace, Vector* impactpoint);
+  friend bool cctree_iterate(const Placement* pa, CC_Tree* ta, unsigned long* ahitflags, const Placement* pb, CC_Tree* tb, unsigned long* bhitflags);
+  friend bool check_trace (const Placement* pa, const CollisionCluster* a, unsigned long* ahitflags, const Line* trace, Vector* impactpoint);
+  friend bool check_collision (const Placement* pa, const CollisionCluster* a, unsigned long* ahitflags, const Placement* pb, const CollisionCluster* b, unsigned long* bhitflags);
+};
+
+bool sphere_sphere_collision( Vector m1, float r1, Vector m2, float r2);
+bool trace_sphere_collision( Vector m, float r, const Line* l, Vector* impactpoint);
+
+void setflag( unsigned long* flags, unsigned long ID);
+
+void free_CC_Tree( CC_Tree* tree);
+CC_Tree* load_CC_Tree (FILE* stream);
+int save_CC_Tree (CC_Tree* tree, FILE* stream);
+
+#endif
Index: orxonox/trunk/src/command_node.cc
===================================================================
--- orxonox/trunk/src/command_node.cc	(revision 2190)
+++ orxonox/trunk/src/command_node.cc	(revision 2190)
@@ -0,0 +1,246 @@
+/* 
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: Christian Meyer
+   co-programmer: ...
+*/
+
+
+#include "command_node.h"
+#include "keynames.h"
+#include "ini_parser.h"
+#include "world_entity.h"
+
+#include <stdio.h>
+#include <string.h>
+#include <stdlib.h>
+
+using namespace std;
+
+/**
+	\brief constructs a CommandNode to handle remote input
+	\param ID: unique denumerator to identify the node in the network
+*/
+CommandNode::CommandNode (int ID)
+{
+	bound = new List<WorldEntity>();
+	aliases = NULL;
+	netID = ID;
+	bLocalInput = false;
+}
+
+/**
+	\brief constructs a CommandNode to handle local input
+	\param filename: The path and name of the file to load the key bindings from
+*/
+CommandNode::CommandNode (char* filename = DEFAULT_KEYBIND_FILE)
+{
+	aliases = NULL;
+	bLocalInput = true;
+	netID = 0;
+	bound = new List<WorldEntity>();
+	load_bindings (filename);
+}
+
+/**
+	\brief removes the CommandNode from memory
+*/
+CommandNode::~CommandNode ()
+{
+	if( aliases != NULL) free (aliases);
+	if( bound != NULL) delete bound;
+}
+
+/**
+	\brief loads new key bindings from a file
+	\param filename: The path and name of the file to load the bindings from
+*/
+void CommandNode::load_bindings (char* filename)
+{
+	FILE* stream;
+	
+	printf("Loading key bindings from %s\n", filename);
+	
+	if( filename == NULL) filename = DEFAULT_KEYBIND_FILE;
+	
+		// remove old bindings if present
+	if( aliases != NULL)
+	{
+		free (aliases);
+		aliases = NULL;
+	}
+			
+		// create parser
+	IniParser parser (filename);
+	if( parser.get_section ("Bindings") == -1)
+	{
+		printf("Could not find key bindings in %s\n", filename);
+		return;
+	}
+			// allocate empty lookup table
+	aliases = (KeyBindings*) calloc (1, sizeof (KeyBindings));
+	
+	char namebuf[256];
+	char valuebuf[256];
+	memset (namebuf, 0, 256);
+	memset (valuebuf, 0, 256);
+	int* index;
+
+	while( parser.next_var (namebuf, valuebuf) != -1)
+	{
+		index = name_to_index (namebuf);
+		switch( index[0])
+		{
+			case 0:
+				printf("Key binding %d(%s) set to %s\n", index[1], SDLK_to_keyname( index[1]), valuebuf);
+				strcpy (aliases->keys[index[1]], valuebuf);
+				break;
+			case 1:
+				printf("Button binding %d(%s) set to %s\n", index[1], SDLB_to_buttonname( index[1]), valuebuf);
+				strcpy (aliases->buttons[index[1]], valuebuf);
+				break;
+			default:
+				break;
+		}
+		memset (namebuf, 0, 256);
+		memset (valuebuf, 0, 256);
+	}
+}
+
+/**
+	\brief binds a WorldEntity to the CommandNode
+	\param entity: Pointer to the entity to bind
+*/
+void CommandNode::bind (WorldEntity* entity)
+{
+	bound->add (entity, LIST_ADD_NEXT, true);
+}
+
+/**
+	\brief removes an entity from the list of the CommandNode
+	\param entity: Pointer to the entity to relese
+*/
+void CommandNode::unbind (WorldEntity* entity)
+{
+	bound->remove (entity, LIST_FIND_FW);
+}
+
+int* CommandNode::name_to_index (char* name)
+{
+	coord[0] = -1;
+	coord[1] = -1;
+	int c;
+	if( (c = keyname_to_SDLK (name)) != -1)
+	{
+		coord[1] = c;
+		coord[0] = 0;
+	}
+	if( (c = buttonname_to_SDLB (name)) != -1)
+	{
+		coord[1] = c;
+		coord[0] = 1;
+	}
+	return coord;
+}
+
+/**
+	\brief tells the CommandNode to run through all pending events and relay them accordingly
+*/
+void CommandNode::process ()
+{
+	if( bLocalInput) process_local ();
+	else process_network ();
+}
+
+void CommandNode::process_local ()
+{
+	SDL_Event event;
+	Command cmd;
+	
+	while( SDL_PollEvent (&event))
+	{
+		memset (cmd.cmd, 0, CMD_LENGHT); 
+		switch( event.type)
+		{
+			case SDL_KEYDOWN:
+				strcpy (cmd.cmd, aliases->keys[event.key.keysym.sym]);
+				cmd.bUp = false;
+				if( strlen (cmd.cmd) > 0) relay (&cmd);
+				break;
+			case SDL_KEYUP:
+				strcpy( cmd.cmd, aliases->keys[event.key.keysym.sym]);
+				cmd.bUp = true;
+				if( strlen (cmd.cmd) > 0) relay (&cmd);
+				break;
+			case SDL_MOUSEMOTION:
+				strcpy( cmd.cmd, "cursor");
+				cmd.x = event.motion.x;
+				cmd.y = event.motion.y;
+				cmd.xrel = event.motion.xrel;
+				cmd.yrel = event.motion.yrel;
+				break;
+			case SDL_MOUSEBUTTONUP:
+				strcpy( cmd.cmd, aliases->buttons[event.button.button]);
+				cmd.bUp = true;
+				if( strlen (cmd.cmd) > 0) relay (&cmd);
+				break;
+			case SDL_MOUSEBUTTONDOWN:
+				strcpy( cmd.cmd, aliases->buttons[event.button.button]);
+				cmd.bUp = false;
+				if( strlen (cmd.cmd) > 0) relay (&cmd);
+				break;
+			case SDL_JOYAXISMOTION:
+			case SDL_JOYBALLMOTION:
+			case SDL_JOYHATMOTION:
+			case SDL_JOYBUTTONDOWN:
+			case SDL_JOYBUTTONUP:
+				break;
+			default:
+  				Orxonox *orx = Orxonox::getInstance();
+  				orx->event_handler (&event);
+				break;
+		}
+	}
+}
+
+void CommandNode::process_network ()
+{
+
+}
+
+void CommandNode::relay (Command* cmd)
+{
+printf("CommandNode|relay()\n");
+	List<WorldEntity>* plist = bound;
+	
+	Orxonox *orx = Orxonox::getInstance();
+	if( orx->system_command (cmd)) return;
+		
+	if( bLocalInput) send_over_network (cmd);
+	
+	while( (plist = plist->get_next()) != NULL)
+	{
+		plist->get_object()->command (cmd);
+	}
+}
+
+/**
+	\brief sets the network identifier of the CommandNode
+	\param ID: the new ID to use
+*/
+void CommandNode::set_netID (int ID)
+{
+	netID = ID;
+}
+
+void CommandNode::send_over_network (Command* cmd)
+{
+}
Index: orxonox/trunk/src/command_node.h
===================================================================
--- orxonox/trunk/src/command_node.h	(revision 2190)
+++ orxonox/trunk/src/command_node.h	(revision 2190)
@@ -0,0 +1,65 @@
+/*!
+    \file command_node.h
+    \brief Parses keyboard, mouse and remote input
+    
+    Contains methods to parse remote and local input and handles sending of input to remote CommandNodes
+*/
+
+#ifndef COMMAND_NODE_H
+#define COMMAND_NODE_H
+
+#include "stdincl.h"
+
+class WorldEntity;
+
+#define N_STD_KEYS SDLK_LAST
+#define N_BUTTONS 6
+#define DEFAULT_KEYBIND_FILE "default.ini"
+
+//! Key aliasing structure
+/**
+	This structure contains the key aliasing information, e.g. the command strings that
+	have been bound to the keys.
+*/
+typedef struct
+{
+	char keys[N_STD_KEYS][CMD_LENGHT];
+	char buttons[N_BUTTONS][CMD_LENGHT];
+} KeyBindings;
+
+//! Command Node
+/**
+	This class gathers all incoming SDL_Events and processes them. Keyboard, mouse and joystick input is
+	captured and translated into command messages which are passed down to the bound WorldEntities (via WorldEntity::command()).
+	Other SDL_Events are passed to Orxonox::event_handler() to deal with them. If the CommandNode has been created
+	with bLocalInput set to false, it will query the network class for incoming commands that match his netID and pass
+	them on to it's WorldEntities.
+*/
+class CommandNode {
+ private:
+ 	bool bLocalInput;	//!< Identifies the CommandNode that processes local input
+ 	int netID;	//!< Unique identifier that is used to determine between remote CommandNodes
+	KeyBindings* aliases;
+	List<WorldEntity>* bound;	//!< List of WorldEntites that recieve commands from this CommandNode
+	Sint32 coord[2];
+	
+	void relay (Command* cmd);
+	int* name_to_index (char* name);
+	void process_local ();
+	void process_network ();
+	void send_over_network (Command* cmd);
+	
+ public:
+  CommandNode (int ID);
+  CommandNode (char* filename);
+  ~CommandNode ();
+  
+  void load_bindings (char* filename);
+  void bind (WorldEntity* entity);
+  void unbind (WorldEntity* entity);
+  void process ();
+  
+  void set_netID (int ID);
+};
+
+#endif
Index: orxonox/trunk/src/data_tank.cc
===================================================================
--- orxonox/trunk/src/data_tank.cc	(revision 2077)
+++ orxonox/trunk/src/data_tank.cc	(revision 2190)
@@ -19,8 +19,4 @@
 using namespace std;
 
-float DataTank::xOffset = 0;
-float DataTank::yOffset = 0;
-float DataTank::zOffset = 0;
-
 DataTank::DataTank () {}
 DataTank::~DataTank () {}
Index: orxonox/trunk/src/data_tank.h
===================================================================
--- orxonox/trunk/src/data_tank.h	(revision 2077)
+++ orxonox/trunk/src/data_tank.h	(revision 2190)
@@ -10,8 +10,4 @@
   ~DataTank ();
 
-  static float xOffset;
-  static float yOffset;
-  static float zOffset;
-
 };
 
